Package org.apache.sis.metadata.iso.lineage

# Class DefaultAlgorithm

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultAlgorithm

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Algorithm`

public class DefaultAlgorithm extends ISOMetadata implements Algorithm
Details of the methodology by which geographic information was derived from the instrument readings. The following properties are mandatory in a well-formed metadata according ISO 19115:
`LE_Algorithm` `├─citation…………………………` Information identifying the algorithm and version or date. `│ ├─title………………………` Name by which the cited resource is known. `│ └─date…………………………` Reference date for the cited resource. `└─description…………………` Information describing the algorithm used to generate the data.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

Defined in the `sis-metadata` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultAlgorithm()`
  Constructs an initially empty algorithm.
  `DefaultAlgorithm(Algorithm object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultAlgorithm`
  `castOrCopy(Algorithm object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Citation`
  `getCitation()`
  Returns the information identifying the algorithm and version or date.
  `InternationalString`
  `getDescription()`
  Returns the information describing the algorithm used to generate the data.
  `void`
  `setCitation(Citation newValue)`
  Sets the information identifying the algorithm and version or date.
  `void`
  `setDescription(InternationalString newValue)`
  Sets the information describing the algorithm used to generate the data.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultAlgorithm

    public DefaultAlgorithm()
    Constructs an initially empty algorithm.

  - ### DefaultAlgorithm

    public DefaultAlgorithm(Algorithm object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(Algorithm)`

- ## Method Details

  - ### castOrCopy

    public static DefaultAlgorithm castOrCopy(Algorithm object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultAlgorithm`, then it is returned unchanged.
    - Otherwise a new `DefaultAlgorithm` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getCitation

    public Citation getCitation()
    Returns the information identifying the algorithm and version or date.
    Specified by:
      `getCitation` in interface `Algorithm`
    Returns:
      algorithm and version or date, or `null`.

  - ### setCitation

    public void setCitation(Citation newValue)
    Sets the information identifying the algorithm and version or date.
    Parameters:
      `newValue` - the new citation value.

  - ### getDescription

    public InternationalString getDescription()
    Returns the information describing the algorithm used to generate the data.
    Specified by:
      `getDescription` in interface `Algorithm`
    Returns:
      algorithm used to generate the data, or `null`.

  - ### setDescription

    public void setDescription(InternationalString newValue)
    Sets the information describing the algorithm used to generate the data.
    Parameters:
      `newValue` - the new description value.